Subject: Re: bash kills console history
From: Sam Steingold <[email-masked]>
To: [email-masked]
Date: 20 Jun 2003 18:54:02 -0400

> * In message <[email-masked]>
> * On the subject of "Re: bash kills console history"
> * Sent on Fri, 20 Jun 2003 18:41:05 -0400 (EDT)
> * Honorable Igor Pechtchanski <[email-masked]> writes:
>
> On 20 Jun 2003, Sam Steingold wrote:
> 
> > when I start a non-cygwin interactive application in a console window
> > under cmd, I can recall the previous lines with  the <Up> key and edit
> > the current command line with <Left> and <Right>.
> > when I start the same application under bash, I can no longer recall
> > history with <Up> (although <Left>&<Right> still work).
> >
> > What does bash do to disable it?
> > How can I get back history editing?
> >
> > Note that when I run the same program under GDB (which runs under
> > bash!) I do get to edit previous commands with <Up>.
> 
> Does the interactive application check whether its output is a
> console?

yes, and I think it correctly detects that it is running interactively.

> If it does, and bash uses a pty (which is a pipe, not a console), then
> the application may decide that it's not running interactively
> (disabling the history mechanism).

what is the function call that does that?
how can an application disable the history mechanism?
(while preserving the line editing one!)

> When gdb runs the application, it allocates a
> separate console for it, so you get interactivity.

I do not observe this: the application interaction appears right under
the gdb prompt, the screen is not cleared.

> If my guess above is correct, there is no way to fix this short of
> always opening the application in its own console (or fixing the
> application code, if it's available).

the application is CLISP (GPLed ANSI Common Lisp implementation, so,
yes, its sources are available and fixable).

[why - and how?! - would I run the application under GDB if the source
were not available?]

-- 
Sam Steingold (http://www.podval.org/~sds) running RedHat9 GNU/Linux
<http://www.camera.org> <http://www.iris.org.il> <http://www.memri.org/>
<http://www.mideasttruth.com/> <http://www.palestine-central.com/links.html>
A clear conscience is usually the sign of a bad memory.

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/